/*
	* libphase -- 󋵊ǗCu
	* by Yui N., 2003.
	*
	* public domain *
*/

#ifndef LIBPHASE_H
#define LIBPHASE_H

#include <piece.h>
#include <stdlib.h>

/* phase ֐ */
typedef void (*phsProcedure)(int cnt);

/* phsChange() ƂɌĂяoR[obN */
typedef void (*phsChangeCallback)(int PhaseNum);

/* pceAppInit() ŌĂяoCphase ֐e[ũTCYw肷 */
void phsInitialize(int MaxPhases);

/* pceAppExit() ŌĂяoCphase ֐e[uj */
void phsFinalize();

/* phsChange() ƂɃR[obNg΃Rœo^ */
void phsSetChangeCallback(phsChangeCallback pProc);

/* phase  NewPhase ɕύXC֘Atꂽ phase ֐Ăяo悤ɂ */
void phsChange(int NewPhase);

/* phase ֐e[uɊ֐o^ */
void phsSetProcedure(int PhaseNum, phsProcedure PhaseProcedure);

/* pceAppProc() ŌĂяoC݂ phase ֐s*/
void phsRunProc(int cnt);

#ifndef LIBPHASE_DECLARE_GLOBALS
extern phsProcedure				*phsProcs;
extern phsProcedure				phsProc;
extern phsChangeCallback	phsOnChanged;
#endif /* !LIBPHASE_DECLARE_GLOBALS */

#endif /* !LIBPHASE_H */
